package utils;

import com.mysql.jdbc.jdbc2.optional.MysqlDataSource;
import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.naming.directory.Attribute;
import javax.naming.directory.Attributes;
import javax.naming.directory.BasicAttribute;
import javax.naming.directory.BasicAttributes;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;
import javax.sql.DataSource;

public class JNDIExample {

	public static Context getContext() throws NamingException {
		Hashtable<String, String> env = new Hashtable<String, String>();
		env.put(Context.INITIAL_CONTEXT_FACTORY,
				"com.sun.jndi.ldap.LdapCtxFactory");
		env.put(Context.PROVIDER_URL, "ldap://pcfeia406a.vsb.cz:10389/o=jat");
		env.put(Context.SECURITY_CREDENTIALS, "secret");
		env.put(Context.SECURITY_PRINCIPAL, "uid=admin,ou=system");
		env.put(Context.SECURITY_AUTHENTICATION, "simple");

		return new InitialContext(env);
	}

	public static DirContext getDirContext() throws NamingException {
		Hashtable<String, String> env = new Hashtable<String, String>();
		env.put(Context.INITIAL_CONTEXT_FACTORY,
				"com.sun.jndi.ldap.LdapCtxFactory");
		env.put(Context.PROVIDER_URL, "ldap://pcfeia406a.vsb.cz:10389/o=jat");
		env.put(Context.SECURITY_CREDENTIALS, "secret");
		env.put(Context.SECURITY_PRINCIPAL, "uid=admin,ou=system");
		env.put(Context.SECURITY_AUTHENTICATION, "simple");

		return new InitialDirContext(env);
	}

	public static void createDataSource(String login) {
		try {
			DirContext ctx = getDirContext();

			Attributes attrs = new BasicAttributes(true); // case-ignore
			Attribute objclass = new BasicAttribute("objectclass");
			objclass.add("top");
			objclass.add("organizationalUnit");
			attrs.put(objclass);
			attrs.put("ou", login);
			DirContext myContext = ctx.createSubcontext("ou=" + login
					+ ",ou=People", attrs);

			MysqlDataSource ds = new MysqlDataSource();
			ds.setPort(3306);
			ds.setServerName("win456.vsb.cz");
			ds.setDatabaseName("jat");
			ds.setUser("jat");
			ds.setPassword("jat");
			Attributes attrs2 = new BasicAttributes(true); // case-ignore
			Attribute person = new BasicAttribute("objectclass");
			person.add("top");
			person.add("person");
			attrs2.put(person);
			attrs2.put("cn", login);
			attrs2.put("sn", login);
			myContext.bind("cn=" + login + "DS",ds);
		} catch (NamingException e) {
			e.printStackTrace();
		}
	}

	public static boolean existDatasource(String login) {

		try {
			Context ctx = getContext();
			ctx.lookup("cn=" + login + "DS,ou=" + login
					+ ",ou=People");
		} catch (NamingException e) {
			return false;
		}
		return true;
	}

	public static DataSource getDatasource(String login) {
            //TODO ziskani DataSource
            return null;
        }
    
}
